USE [COWS]
GO
/****** Object:  StoredProcedure [dbo].[getVendorOrdersByIDH5FTN]    Script Date: 11/16/2020 8:47:00 AM ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- ================================================================
-- Author:		Lakshmi Kadiyala
-- Create date: 12th July 2011
-- Description:	Returns Vendor Orders matching input parameters
-- ================================================================

ALTER PROCEDURE [dbo].[getVendorOrdersByIDH5FTN] 
	@VendorOrderID INT, 
	@H5CustID INT,
	@FTN varchar(20) 	
AS
BEGIN
SET NOCOUNT ON;

BEGIN TRY

	IF ISNULL(@VendorOrderID,0) = 0 AND ISNULL(@H5CustID,0) = 0 AND ISNULL(@FTN,'') = ''
		RETURN 

	DECLARE @SearchResult TABLE
	(
		VNDR_ORDR_ID INT,
		ORDR_ID INT,
		TRMTG_CD BIT,
		VNDR_ORDR_TYPE_ID TINYINT,
		VNDR_ORDR_TYPE_DESC VARCHAR(25),
		VNDR_CD VARCHAR(30),
		VNDR_NME VARCHAR(50),
		CTRY_NME VARCHAR(50),
		EMAILCOUNT TINYINT,
		CUST_ID INT,
		FTN varchar(20),
		CSG_LVL_ID TINYINT
	)

	INSERT INTO @SearchResult
	SELECT
		VO.VNDR_ORDR_ID,
		VO.ORDR_ID,
		VO.TRMTG_CD,
		VO.VNDR_ORDR_TYPE_ID,
		LVOT.VNDR_ORDR_TYPE_DES,
		LV.VNDR_CD,
		LV.VNDR_NME,
		LC.CTRY_NME,
		COUNT(VOE.VNDR_ORDR_EMAIL_ID) EMAILCOUNT,
		ISNULL(HF.CUST_ID, 0) CUST_ID,
		ISNULL(FO.FTN, ISNULL(CONVERT(varchar(20),i.ORDR_ID), ISNULL(CONVERT(varchar(20),ncco.ORDR_ID),0))) FTN,
		ISNULL(o.CSG_LVL_ID,0) AS CSG_LVL_ID
	FROM dbo.VNDR_ORDR VO WITH (NOLOCK)
	INNER JOIN dbo.VNDR_FOLDR VF WITH (NOLOCK) ON VO.VNDR_FOLDR_ID = VF.VNDR_FOLDR_ID
	INNER JOIN dbo.LK_VNDR LV WITH (NOLOCK) ON VF.VNDR_CD = LV.VNDR_CD
	LEFT OUTER JOIN dbo.LK_VNDR_ORDR_TYPE LVOT WITH (NOLOCK) ON VO.VNDR_ORDR_TYPE_ID = LVOT.VNDR_ORDR_TYPE_ID
	LEFT OUTER JOIN dbo.LK_CTRY LC WITH (NOLOCK) ON VF.CTRY_CD = LC.CTRY_CD
	LEFT OUTER JOIN dbo.FSA_ORDR FO WITH (NOLOCK) ON VO.ORDR_ID = FO.ORDR_ID
	LEFT OUTER JOIN dbo.ORDR O WITH (NOLOCK) ON VO.VNDR_ORDR_ID = O.ORDR_ID
	LEFT OUTER JOIN dbo.H5_FOLDR HF WITH (NOLOCK) ON O.H5_FOLDR_ID = HF.H5_FOLDR_ID
	LEFT OUTER JOIN dbo.VNDR_ORDR_EMAIL VOE WITH (NOLOCK) ON VO.VNDR_ORDR_ID = VOE.VNDR_ORDR_ID
	LEFT OUTER JOIN dbo.IPL_ORDR i WITH (NOLOCK) ON VO.ORDR_ID = i.ORDR_ID
	LEFT OUTER JOIN dbo.NCCO_ORDR ncco WITH (NOLOCK) ON VO.ORDR_ID = ncco.ORDR_ID
	WHERE (VO.VNDR_ORDR_ID = @VendorOrderID) 			
	OR (HF.CUST_ID = @H5CustID)
	OR (CONVERT(varchar(20),FO.FTN) = @FTN)
	OR (CONVERT(varchar(20),i.ORDR_ID) = @FTN)
	OR (CONVERT(varchar(20),ncco.ORDR_ID) = @FTN)
	GROUP BY VO.VNDR_ORDR_ID, VO.ORDR_ID, VO.TRMTG_CD, VO.VNDR_ORDR_TYPE_ID, 
			 LVOT.VNDR_ORDR_TYPE_DES, LV.VNDR_CD, LV.VNDR_NME, LC.CTRY_NME, CUST_ID, FTN, i.ORDR_ID, ncco.ORDR_ID, o.CSG_LVL_ID

	IF ((SELECT COUNT(*) FROM @SearchResult) > 0)
	BEGIN
		IF(@VendorOrderID > 0)
			DELETE @SearchResult WHERE VNDR_ORDR_ID <> @VendorOrderID
		IF(@H5CustID > 0)
			DELETE @SearchResult WHERE CUST_ID <> @H5CustID
		IF(@FTN > '')
			DELETE @SearchResult WHERE FTN <> @FTN
	END

	SELECT * FROM @SearchResult	
END TRY
BEGIN CATCH
	EXEC [dbo].[insertErrorInfo]
END CATCH
END